A binary search solution to 3SumQuadratic solution to 3SumFinding unique triplets adding up to 03Sum implementationCount of Smaller Numbers After Self3sum leetcode problem using 2sum3-Sum Problem in PythonSolving “Quadruple sum” problem using dynamic programmingFind all combinations of 4 elements whose sum equals a target in PythonClosest 3Sum in ScalaLeetcode Three Sum in PythonHash table solution to twoSum

Resetting two CD4017 counters simultaneously, only one resets

Is it okay / does it make sense for another player to join a running game of Munchkin?

A known event to a history junkie

Indicating multiple different modes of speech (fantasy language or telepathy)

How will losing mobility of one hand affect my career as a programmer?

Can a malicious addon access internet history and such in chrome/firefox?

Meta programming: Declare a new struct on the fly

Is there a problem with hiding "forgot password" until it's needed?

I'm in charge of equipment buying but no one's ever happy with what I choose. How to fix this?

The most efficient algorithm to find all possible integer pairs which sum to a given integer

For airliners, what prevents wing strikes on landing in bad weather?

Calculating the number of days between 2 dates in Excel

Can the electrostatic force be infinite in magnitude?

Latex for-and in equation

Lifted its hind leg on or lifted its hind leg towards?

word describing multiple paths to the same abstract outcome

How do I repair my stair bannister?

Greatest common substring

Stereotypical names

A workplace installs custom certificates on personal devices, can this be used to decrypt HTTPS traffic?

What should I use for Mishna study?

How do ultrasonic sensors differentiate between transmitted and received signals?

Hostile work environment after whistle-blowing on coworker and our boss. What do I do?

Is there a good way to store credentials outside of a password manager?



A binary search solution to 3Sum


Quadratic solution to 3SumFinding unique triplets adding up to 03Sum implementationCount of Smaller Numbers After Self3sum leetcode problem using 2sum3-Sum Problem in PythonSolving “Quadruple sum” problem using dynamic programmingFind all combinations of 4 elements whose sum equals a target in PythonClosest 3Sum in ScalaLeetcode Three Sum in PythonHash table solution to twoSum













3












$begingroup$


I tried a binary solution to 3Sum problem in LeetCode:




Given an array nums of $n$ integers, are there elements $a$, $b$, $c$ in nums such that $a + b + c = 0$? Find all unique triplets in the array which gives the sum of zero.



Note:



The solution set must not contain duplicate triplets.



Example:



Given array nums = [-1, 0, 1, 2, -1, -4],

A solution set is:
[
[-1, 0, 1],
[-1, -1, 2]
]



My plan: divide and conquer threeSum to



  1. an iteration

  2. and a two_Sum problem.

  3. break two_Sum problem to

    1. a loop

    2. binary search


The complexity is: $O(n^2logn)$.



 class Solution:
"""
Solve the problem by three module funtion
threeSum
two_sum
bi_search
"""
def __init__(self):
self.triplets: List[List[int]] = []

def threeSum(self, nums, target=0) -> List[List[int]]:
"""
:type nums: List[int]
:type target: int
"""
nums.sort() #sort for skip duplicate and binary search

if len(nums) < 3:
return []

i = 0
while i < len(nums) - 2:
complement = target - nums[i]

self.two_sum(nums[i+1:], complement)
i += 1 #increment the index
while i < len(nums) -2 and nums[i] == nums[i-1]: #skip the duplicates, pass unique complement to next level.
i += 1

return self.triplets


def two_sum(self, nums, target):
"""
:type nums: List[int]
:tppe target: int
:rtype: List[List[int]]
"""
# nums = sorted(nums) #temporarily for testing.
if len(nums) < 2:
return []

i = 0
while i < len(nums) -1:
complement = target - nums[i]

if self.bi_search(nums[i+1:], complement) != None:

# 0 - target = threeSum's fixer
self.triplets.append([0-target, nums[i], complement])
i += 1

while i < len(nums) and nums[i] == nums[i-1]:
i += 1

def bi_search(self, L, find) -> int:
"""
:type L: List[int]
:type find: int
"""
if len(L) < 1: #terninating case
return None
else:
mid = len(L) // 2
if find == L[mid]:
return find

if find > L[mid]:
upper_half = L[mid+1:]
return self.bi_search(upper_half, find)
if find < L[mid]:
lower_half = L[:mid] #mid not mid-1
return self.bi_search(lower_half, find)


I ran it but get the report




Status: Time Limit Exceeded




Could you please give any hints to refactor?



Is binary search is an appropriate strategy?










share|improve this question









New contributor




Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.







$endgroup$











  • $begingroup$
    Binary search is good at O(log n), but hash search is better at O(1).
    $endgroup$
    – Lawnmower Man
    Mar 23 at 0:40















3












$begingroup$


I tried a binary solution to 3Sum problem in LeetCode:




Given an array nums of $n$ integers, are there elements $a$, $b$, $c$ in nums such that $a + b + c = 0$? Find all unique triplets in the array which gives the sum of zero.



Note:



The solution set must not contain duplicate triplets.



Example:



Given array nums = [-1, 0, 1, 2, -1, -4],

A solution set is:
[
[-1, 0, 1],
[-1, -1, 2]
]



My plan: divide and conquer threeSum to



  1. an iteration

  2. and a two_Sum problem.

  3. break two_Sum problem to

    1. a loop

    2. binary search


The complexity is: $O(n^2logn)$.



 class Solution:
"""
Solve the problem by three module funtion
threeSum
two_sum
bi_search
"""
def __init__(self):
self.triplets: List[List[int]] = []

def threeSum(self, nums, target=0) -> List[List[int]]:
"""
:type nums: List[int]
:type target: int
"""
nums.sort() #sort for skip duplicate and binary search

if len(nums) < 3:
return []

i = 0
while i < len(nums) - 2:
complement = target - nums[i]

self.two_sum(nums[i+1:], complement)
i += 1 #increment the index
while i < len(nums) -2 and nums[i] == nums[i-1]: #skip the duplicates, pass unique complement to next level.
i += 1

return self.triplets


def two_sum(self, nums, target):
"""
:type nums: List[int]
:tppe target: int
:rtype: List[List[int]]
"""
# nums = sorted(nums) #temporarily for testing.
if len(nums) < 2:
return []

i = 0
while i < len(nums) -1:
complement = target - nums[i]

if self.bi_search(nums[i+1:], complement) != None:

# 0 - target = threeSum's fixer
self.triplets.append([0-target, nums[i], complement])
i += 1

while i < len(nums) and nums[i] == nums[i-1]:
i += 1

def bi_search(self, L, find) -> int:
"""
:type L: List[int]
:type find: int
"""
if len(L) < 1: #terninating case
return None
else:
mid = len(L) // 2
if find == L[mid]:
return find

if find > L[mid]:
upper_half = L[mid+1:]
return self.bi_search(upper_half, find)
if find < L[mid]:
lower_half = L[:mid] #mid not mid-1
return self.bi_search(lower_half, find)


I ran it but get the report




Status: Time Limit Exceeded




Could you please give any hints to refactor?



Is binary search is an appropriate strategy?










share|improve this question









New contributor




Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.







$endgroup$











  • $begingroup$
    Binary search is good at O(log n), but hash search is better at O(1).
    $endgroup$
    – Lawnmower Man
    Mar 23 at 0:40













3












3








3





$begingroup$


I tried a binary solution to 3Sum problem in LeetCode:




Given an array nums of $n$ integers, are there elements $a$, $b$, $c$ in nums such that $a + b + c = 0$? Find all unique triplets in the array which gives the sum of zero.



Note:



The solution set must not contain duplicate triplets.



Example:



Given array nums = [-1, 0, 1, 2, -1, -4],

A solution set is:
[
[-1, 0, 1],
[-1, -1, 2]
]



My plan: divide and conquer threeSum to



  1. an iteration

  2. and a two_Sum problem.

  3. break two_Sum problem to

    1. a loop

    2. binary search


The complexity is: $O(n^2logn)$.



 class Solution:
"""
Solve the problem by three module funtion
threeSum
two_sum
bi_search
"""
def __init__(self):
self.triplets: List[List[int]] = []

def threeSum(self, nums, target=0) -> List[List[int]]:
"""
:type nums: List[int]
:type target: int
"""
nums.sort() #sort for skip duplicate and binary search

if len(nums) < 3:
return []

i = 0
while i < len(nums) - 2:
complement = target - nums[i]

self.two_sum(nums[i+1:], complement)
i += 1 #increment the index
while i < len(nums) -2 and nums[i] == nums[i-1]: #skip the duplicates, pass unique complement to next level.
i += 1

return self.triplets


def two_sum(self, nums, target):
"""
:type nums: List[int]
:tppe target: int
:rtype: List[List[int]]
"""
# nums = sorted(nums) #temporarily for testing.
if len(nums) < 2:
return []

i = 0
while i < len(nums) -1:
complement = target - nums[i]

if self.bi_search(nums[i+1:], complement) != None:

# 0 - target = threeSum's fixer
self.triplets.append([0-target, nums[i], complement])
i += 1

while i < len(nums) and nums[i] == nums[i-1]:
i += 1

def bi_search(self, L, find) -> int:
"""
:type L: List[int]
:type find: int
"""
if len(L) < 1: #terninating case
return None
else:
mid = len(L) // 2
if find == L[mid]:
return find

if find > L[mid]:
upper_half = L[mid+1:]
return self.bi_search(upper_half, find)
if find < L[mid]:
lower_half = L[:mid] #mid not mid-1
return self.bi_search(lower_half, find)


I ran it but get the report




Status: Time Limit Exceeded




Could you please give any hints to refactor?



Is binary search is an appropriate strategy?










share|improve this question









New contributor




Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.







$endgroup$




I tried a binary solution to 3Sum problem in LeetCode:




Given an array nums of $n$ integers, are there elements $a$, $b$, $c$ in nums such that $a + b + c = 0$? Find all unique triplets in the array which gives the sum of zero.



Note:



The solution set must not contain duplicate triplets.



Example:



Given array nums = [-1, 0, 1, 2, -1, -4],

A solution set is:
[
[-1, 0, 1],
[-1, -1, 2]
]



My plan: divide and conquer threeSum to



  1. an iteration

  2. and a two_Sum problem.

  3. break two_Sum problem to

    1. a loop

    2. binary search


The complexity is: $O(n^2logn)$.



 class Solution:
"""
Solve the problem by three module funtion
threeSum
two_sum
bi_search
"""
def __init__(self):
self.triplets: List[List[int]] = []

def threeSum(self, nums, target=0) -> List[List[int]]:
"""
:type nums: List[int]
:type target: int
"""
nums.sort() #sort for skip duplicate and binary search

if len(nums) < 3:
return []

i = 0
while i < len(nums) - 2:
complement = target - nums[i]

self.two_sum(nums[i+1:], complement)
i += 1 #increment the index
while i < len(nums) -2 and nums[i] == nums[i-1]: #skip the duplicates, pass unique complement to next level.
i += 1

return self.triplets


def two_sum(self, nums, target):
"""
:type nums: List[int]
:tppe target: int
:rtype: List[List[int]]
"""
# nums = sorted(nums) #temporarily for testing.
if len(nums) < 2:
return []

i = 0
while i < len(nums) -1:
complement = target - nums[i]

if self.bi_search(nums[i+1:], complement) != None:

# 0 - target = threeSum's fixer
self.triplets.append([0-target, nums[i], complement])
i += 1

while i < len(nums) and nums[i] == nums[i-1]:
i += 1

def bi_search(self, L, find) -> int:
"""
:type L: List[int]
:type find: int
"""
if len(L) < 1: #terninating case
return None
else:
mid = len(L) // 2
if find == L[mid]:
return find

if find > L[mid]:
upper_half = L[mid+1:]
return self.bi_search(upper_half, find)
if find < L[mid]:
lower_half = L[:mid] #mid not mid-1
return self.bi_search(lower_half, find)


I ran it but get the report




Status: Time Limit Exceeded




Could you please give any hints to refactor?



Is binary search is an appropriate strategy?







python python-3.x programming-challenge time-limit-exceeded k-sum






share|improve this question









New contributor




Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.











share|improve this question









New contributor




Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









share|improve this question




share|improve this question








edited 2 days ago









esote

2,83111038




2,83111038






New contributor




Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









asked Mar 22 at 13:06









AliceAlice

1754




1754




New contributor




Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.





New contributor





Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.






Alice is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.











  • $begingroup$
    Binary search is good at O(log n), but hash search is better at O(1).
    $endgroup$
    – Lawnmower Man
    Mar 23 at 0:40
















  • $begingroup$
    Binary search is good at O(log n), but hash search is better at O(1).
    $endgroup$
    – Lawnmower Man
    Mar 23 at 0:40















$begingroup$
Binary search is good at O(log n), but hash search is better at O(1).
$endgroup$
– Lawnmower Man
Mar 23 at 0:40




$begingroup$
Binary search is good at O(log n), but hash search is better at O(1).
$endgroup$
– Lawnmower Man
Mar 23 at 0:40










1 Answer
1






active

oldest

votes


















7












$begingroup$

Your bi_search() method is recursive. It doesn’t have to be. Python does not do tail-call-optimization: it won’t automatically turn the recursion into a loop. Instead of if len(L) < 1:, use a while len(L) > 0: loop, and assign to (eg, L = L[:mid]) instead of doing a recursive call.



Better: don’t modify L at all, which involves copying a list of many numbers multiple times, a time consuming operation. Instead, maintain a lo and hi index, and just update the indexes as you search.



Even better: use a built in binary search from import bisect.






share|improve this answer









$endgroup$












    Your Answer





    StackExchange.ifUsing("editor", function ()
    return StackExchange.using("mathjaxEditing", function ()
    StackExchange.MarkdownEditor.creationCallbacks.add(function (editor, postfix)
    StackExchange.mathjaxEditing.prepareWmdForMathJax(editor, postfix, [["\$", "\$"]]);
    );
    );
    , "mathjax-editing");

    StackExchange.ifUsing("editor", function ()
    StackExchange.using("externalEditor", function ()
    StackExchange.using("snippets", function ()
    StackExchange.snippets.init();
    );
    );
    , "code-snippets");

    StackExchange.ready(function()
    var channelOptions =
    tags: "".split(" "),
    id: "196"
    ;
    initTagRenderer("".split(" "), "".split(" "), channelOptions);

    StackExchange.using("externalEditor", function()
    // Have to fire editor after snippets, if snippets enabled
    if (StackExchange.settings.snippets.snippetsEnabled)
    StackExchange.using("snippets", function()
    createEditor();
    );

    else
    createEditor();

    );

    function createEditor()
    StackExchange.prepareEditor(
    heartbeatType: 'answer',
    autoActivateHeartbeat: false,
    convertImagesToLinks: false,
    noModals: true,
    showLowRepImageUploadWarning: true,
    reputationToPostImages: null,
    bindNavPrevention: true,
    postfix: "",
    imageUploader:
    brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
    contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
    allowUrls: true
    ,
    onDemand: true,
    discardSelector: ".discard-answer"
    ,immediatelyShowMarkdownHelp:true
    );



    );






    Alice is a new contributor. Be nice, and check out our Code of Conduct.









    draft saved

    draft discarded


















    StackExchange.ready(
    function ()
    StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2fcodereview.stackexchange.com%2fquestions%2f215994%2fa-binary-search-solution-to-3sum%23new-answer', 'question_page');

    );

    Post as a guest















    Required, but never shown

























    1 Answer
    1






    active

    oldest

    votes








    1 Answer
    1






    active

    oldest

    votes









    active

    oldest

    votes






    active

    oldest

    votes









    7












    $begingroup$

    Your bi_search() method is recursive. It doesn’t have to be. Python does not do tail-call-optimization: it won’t automatically turn the recursion into a loop. Instead of if len(L) < 1:, use a while len(L) > 0: loop, and assign to (eg, L = L[:mid]) instead of doing a recursive call.



    Better: don’t modify L at all, which involves copying a list of many numbers multiple times, a time consuming operation. Instead, maintain a lo and hi index, and just update the indexes as you search.



    Even better: use a built in binary search from import bisect.






    share|improve this answer









    $endgroup$

















      7












      $begingroup$

      Your bi_search() method is recursive. It doesn’t have to be. Python does not do tail-call-optimization: it won’t automatically turn the recursion into a loop. Instead of if len(L) < 1:, use a while len(L) > 0: loop, and assign to (eg, L = L[:mid]) instead of doing a recursive call.



      Better: don’t modify L at all, which involves copying a list of many numbers multiple times, a time consuming operation. Instead, maintain a lo and hi index, and just update the indexes as you search.



      Even better: use a built in binary search from import bisect.






      share|improve this answer









      $endgroup$















        7












        7








        7





        $begingroup$

        Your bi_search() method is recursive. It doesn’t have to be. Python does not do tail-call-optimization: it won’t automatically turn the recursion into a loop. Instead of if len(L) < 1:, use a while len(L) > 0: loop, and assign to (eg, L = L[:mid]) instead of doing a recursive call.



        Better: don’t modify L at all, which involves copying a list of many numbers multiple times, a time consuming operation. Instead, maintain a lo and hi index, and just update the indexes as you search.



        Even better: use a built in binary search from import bisect.






        share|improve this answer









        $endgroup$



        Your bi_search() method is recursive. It doesn’t have to be. Python does not do tail-call-optimization: it won’t automatically turn the recursion into a loop. Instead of if len(L) < 1:, use a while len(L) > 0: loop, and assign to (eg, L = L[:mid]) instead of doing a recursive call.



        Better: don’t modify L at all, which involves copying a list of many numbers multiple times, a time consuming operation. Instead, maintain a lo and hi index, and just update the indexes as you search.



        Even better: use a built in binary search from import bisect.







        share|improve this answer












        share|improve this answer



        share|improve this answer










        answered Mar 22 at 13:59









        AJNeufeldAJNeufeld

        6,4501621




        6,4501621




















            Alice is a new contributor. Be nice, and check out our Code of Conduct.









            draft saved

            draft discarded


















            Alice is a new contributor. Be nice, and check out our Code of Conduct.












            Alice is a new contributor. Be nice, and check out our Code of Conduct.











            Alice is a new contributor. Be nice, and check out our Code of Conduct.














            Thanks for contributing an answer to Code Review Stack Exchange!


            • Please be sure to answer the question. Provide details and share your research!

            But avoid


            • Asking for help, clarification, or responding to other answers.

            • Making statements based on opinion; back them up with references or personal experience.

            Use MathJax to format equations. MathJax reference.


            To learn more, see our tips on writing great answers.




            draft saved


            draft discarded














            StackExchange.ready(
            function ()
            StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2fcodereview.stackexchange.com%2fquestions%2f215994%2fa-binary-search-solution-to-3sum%23new-answer', 'question_page');

            );

            Post as a guest















            Required, but never shown





















































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown

































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown







            -k-sum, programming-challenge, python, python-3.x, time-limit-exceeded

            Popular posts from this blog

            Mobil Contents History Mobil brands Former Mobil brands Lukoil transaction Mobil UK Mobil Australia Mobil New Zealand Mobil Greece Mobil in Japan Mobil in Canada Mobil Egypt See also References External links Navigation menuwww.mobil.com"Mobil Corporation"the original"Our Houston campus""Business & Finance: Socony-Vacuum Corp.""Popular Mechanics""Lubrite Technologies""Exxon Mobil campus 'clearly happening'""Toledo Blade - Google News Archive Search""The Lion and the Moose - How 2 Executives Pulled off the Biggest Merger Ever""ExxonMobil Press Release""Lubricants""Archived copy"the original"Mobil 1™ and Mobil Super™ motor oil and synthetic motor oil - Mobil™ Motor Oils""Mobil Delvac""Mobil Industrial website""The State of Competition in Gasoline Marketing: The Effects of Refiner Operations at Retail""Mobil Travel Guide to become Forbes Travel Guide""Hotel Rankings: Forbes Merges with Mobil"the original"Jamieson oil industry history""Mobil news""Caltex pumps for control""Watchdog blocks Caltex bid""Exxon Mobil sells service station network""Mobil Oil New Zealand Limited is New Zealand's oldest oil company, with predecessor companies having first established a presence in the country in 1896""ExxonMobil subsidiaries have a business history in New Zealand stretching back more than 120 years. We are involved in petroleum refining and distribution and the marketing of fuels, lubricants and chemical products""Archived copy"the original"Exxon Mobil to Sell Its Japanese Arm for $3.9 Billion""Gas station merger will end Esso and Mobil's long run in Japan""Esso moves to affiliate itself with PC Optimum, no longer Aeroplan, in loyalty point switch""Mobil brand of gas stations to launch in Canada after deal for 213 Loblaws-owned locations""Mobil Nears Completion of Rebranding 200 Loblaw Gas Stations""Learn about ExxonMobil's operations in Egypt""Petrol and Diesel Service Stations in Egypt - Mobil"Official websiteExxon Mobil corporate websiteMobil Industrial official websiteeeeeeeeDA04275022275790-40000 0001 0860 5061n82045453134887257134887257

            Frič See also Navigation menuinternal link

            Identify plant with long narrow paired leaves and reddish stems Planned maintenance scheduled April 17/18, 2019 at 00:00UTC (8:00pm US/Eastern) Announcing the arrival of Valued Associate #679: Cesar Manara Unicorn Meta Zoo #1: Why another podcast?What is this plant with long sharp leaves? Is it a weed?What is this 3ft high, stalky plant, with mid sized narrow leaves?What is this young shrub with opposite ovate, crenate leaves and reddish stems?What is this plant with large broad serrated leaves?Identify this upright branching weed with long leaves and reddish stemsPlease help me identify this bulbous plant with long, broad leaves and white flowersWhat is this small annual with narrow gray/green leaves and rust colored daisy-type flowers?What is this chilli plant?Does anyone know what type of chilli plant this is?Help identify this plant